# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.


from .Layer import Layer
from Controllers.TensorFormat import LayerIOFormat, LayerIOFormatPair

class ReshapeHWC(Layer):
    # Temporary hack:
    # Since there is no Myriad implementation of the ReshapeHWC, we force the ReshapeHWC to
    # operate with input/output as HWC_compact. With this memory representation, the ReshapeHWC behaves
    # just as an Identity layer, hence it will be translated into a NoOp-inplace
    #
    # A proper implementation of Reshape that takes into account the tensor strides
    # needs to be implemented on Myriad.
    _supported_IO_formats = [
        (LayerIOFormat.nhwc_compact(), LayerIOFormat.nhwc_compact())
        ]

    def __init__(self, *args):
        super().__init__(*args)
        self.setInPlace()
