# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.

from Controllers.Parsers.Parser.Pooling import Pooling
from . import Helpers as tf_helpers

from Controllers.EnumController import throw_error, ErrorTable, compiler_assert

def load(obj, operations, feed_dict):
    try:
        axis = obj.get_attr('axis')
    except:
        axis = tf_helpers.findTensorValue(obj.inputs[1].name, operations)

    x = Pooling(obj.name, [tf_helpers.getInputNames(obj)[0]], tf_helpers.getOutputNames(obj))
    x.loadType(Pooling.Type.AVE)
    # Loading of kernel size is going to be done in parsing after the tensor sizes
    # have been loaded because the tensor sizes can be dynamic and the correct
    # input must be feed in order to get the input tensor shapes.
    #x.loadKernelSize(int(input_shape[1]), int(input_shape[2]))
    x.loadStrideSize(1, 1)
    x.loadPadding(0, 0, 0, 0)

    x.loadGlobal(True)

    return [x]
