# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.

import Controllers.Parsers.Parser.Convolution2D as Layer


def isSpatialConv(layer):
    assert isinstance(layer, Layer.Convolution2DUniversal)
    return (layer.getInputTensorSizes()[0][1] <= 4)\
            and (layer.kernelWidth == layer.kernelHeight)\
            and ((layer.kernelWidth >> 1) < 5) and ((layer.kernelWidth & 1) == 1)\
            and (layer.strideWidth == layer.strideHeight)\
            and (layer.strideWidth < 5)\
            and (layer.dilationFactor == 1)
